<?php

//////////////////////////////////////////////////////////////
//===========================================================
// ftpservers_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Julien
// Date:       19th July 2012
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function storage_theme(){

global $theme, $globals, $kernel, $user, $l, $error, $storage, $storage_servers, $servers, $servergroups, $done;

softheader($l['<title>']);

if(!empty($request_test)){
	echo $done_test;
	return true;
}

echo '
<div class="bg" >
<div class="row mx-auto my-3">
	<div class="col-10">
		<h4 class="text-dark"><i class="fas fa-hdd"></i> '.$l['plans_tit'].'</h4>
	</div>
	<div class="col-2 text-right d-flex align-items-center justify-content-end">
		<span class="search_btn icon-fix d-flex align-items-center justify-content-center"><a href="javascript:showsearch();" class="text-light"><i class="fas fa-search"></i></a></span>
	</div>
</div>
';

error_handle($error);

// Check which stid belongs to which servers
foreach($storage_servers as $p => $q){
	if($q['serid'] == -1){
		$ipgp[$q['stid']][] = $l['all_servers'];
	}elseif($q['serid'] == -2){
		$ipgp[$q['stid']][] = '[Group] '.$servergroups[$q['sgid']]['sg_name'];
	}else{
		foreach($servers as $x => $y){
			if($q['serid'] == $y['serid'] || $q['sgid'] == $y['sgid']){
				$ipgp[$q['stid']][] = $y['server_name'];
			}
		}
	}
}

echo '<script language="javascript" type="text/javascript"><!-- // --><![CDATA[
	let storageflare = {"LVM":"<span class=\"roundflare text-always-white bg-orange\">", 
		"Thin LVM":"<span class=\"roundflare text-always-white bg-orange\">",
		"OpenVZ":"<span class=\"roundflare text-always-white bg-success\">",
		"File":"<span class=\"roundflare text-always-white bg-success\">",
		"ZFS":"<span class=\"roundflare text-always-white bg-warning\">",
		"ZFS Thin":"<span class=\"roundflare text-always-white bg-warning\">",
		"ZFS Compresse":"<span class=\"roundflare text-always-white bg-warning\">",
		"ZFS Thin Compressed":"<span class=\"roundflare text-always-white bg-warning\">",
		"Ceph Block Device":"<span class=\"roundflare text-always-white bg-danger\">",
		"Lightbit":"<span class=\"roundflare text-always-white bg-yrange\">",
		"Linbit DRBD":"<span class=\"roundflare text-always-white bg-yrange\">"
		};
function Delstorage(stid, ele){

	stid = stid || 0;
	
	// List of ids to delete
	var storage_list = new Array();
	
	if(stid < 1){
		
		if($(ele).parent().prev().find("select").val() != 1){
			showalert("'.$l['no_action'].'","1");
			return false;
		}
		
		$(".ios:checked").each(function() {
			storage_list.push($(this).val());
		});
		
	}else{
		
		storage_list.push(stid);
		
	}
	
	if(storage_list.length < 1){
		showalert("'.$l['nothing_selected'].'","1");
		return false;
	}
	
	showalert("'.$l['del_conf'].'" ,"3" ,function(confirm){
		if(confirm == false){
			return false;
		}else{
			var finalData = new Object();
			finalData["delete"] = storage_list.join(",");
			
			//alert(finalData);
			//return false;
			
			$("#progress_bar").show();
			
			$.ajax({
				type: "POST",
				url: "'.$globals['index'].'act=storage&api=json",
				data : finalData,
				dataType : "json",
				success: function(data){
					$("#progress_bar").hide();
					if("done" in data){
						setTimeout(function(){showalert("'.$l['action_completed'].'");$("#alert-modal").on("hidden.bs.modal", function (e) {
						location.reload(true);
						});} ,200);
					}
					if("error" in data){
						setTimeout(function(){showalert(data["error"],"1");
						$("#alert-modal").on("hidden.bs.modal", function (e) {
						location.reload(true);
						});} ,200);
					
					if("fatal_error_text" in data){
						setTimeout(function(){showalert(data["fatal_error_text"],"1");} ,200);
					}
					
					}
				},
				error: function(data) {
					$("#progress_bar").hide();
					//alert(data.description);
					return false;
				}
			});
		}
	});
	return false;
};

// ]]></script>
<div id="showsearch" class="mt-3" style="display:'.(optREQ('search') || (!empty($storage) && !empty($globals['showsearch'])) ? "" : "none").';">
<br>
	<form accept-charset="'.$globals['charset'].'" name="storage" method="GET" action="" class="form-horizontal">
	<input type="hidden" name="act" value="storage">	
		<div class="form-group_head">
			<div class="row mx-auto w-100">
					<div class="col-sm-4"><label>'.$l['sbyname'].'</label>
						<input type="text" class="form-control" name="name" id="name" size="30" value="'.REQval('name','').'"/>
					</div>
						<div class="col-sm-4"><label>'.$l['sbypath'].'</label>
							<input type="text" class="form-control" name="path" id="path" size="30" value="'.REQval('path', '').'" />
						</div>
					<div class="col-sm-4"><label>' . $l['st_servers'] . '</label>
						<select name="servers_search" id="servers_search" class="form-control virt-select">
							<option value="-1" ' . REQselect('servers_search', -1) . '>' . $l['all_servers'] . '</option>';
							foreach ($servers as $k => $v) {
								echo '<option value="' . $k . '" ' . REQselect('servers_search', $k) . '>' . $v['server_name'] . '</option>';
							}
							echo'
						</select>
					</div>
			</div>
			<div class="row mx-auto w-100 my-2">
				<div class="col-sm-12 text-center"><button type="submit" name="search" class="go_btn mt-2" value="Search"/>'.$l['submit'].'</button></div> 
			</div>
		</div>
	</form>
</div>';

if(!empty($done)){
	show_alert($l['saved']);
	//echo '<div class="notice"><b>NOTE : </b>&nbsp; '..'</div>';
}

if(empty($storage)){
	optREQ('search') ? show_alert($l['no_res'], "2") : show_alert($l['no_backupservers'], "2");
	echo '<div class="notice"><b>NOTE : </b>&nbsp; '.(optREQ('search') ? $l['no_res'] : $l['no_backupservers']).'</div>';
	
}else{
	echo'<div class="row mx-auto w-100 mt-3">
	<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
		page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
	echo'
	</div>
	<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3">
		<div class="bottom-menu float-right w-100">
            <div class="row my-auto">
                <div class="p-0">
                    <label>'.$l['with_selected'].'</label>
                </div>
                <div class="col p-0">
					<select name="storage_task_select" id="storage_task_select" class="custom-select">
						<option value="0">---</option>
						<option value="1">'.$l['ms_delete'].'</option>
					</select>
                </div>
                <div class="pl-2">
					<input type="submit" id ="storage_submit" class="go_btn" name="storage_submit" value="'.$l['go'].'" onclick="Delstorage(0, this); return false;">
                </div>
            </div>
		</div>
	</div>
</div>
<form accept-charset="'.$globals['charset'].'" name="multi_storage" id="multi_storage" method="post" action="" class="form-horizontal">
<div class="w-100 mx-auto sticky">
'.get_num_records($globals['num_res']).'
<table class="table table-hover tablesorter">
<tr>
	<th align="center" class="min_width">'.$l['id'].'</th>
	<th align="center">'.$l['name'].'</th>
	<th align="center">'.$l['st_servers'].'</th>
	<th align="center">'.$l['st_uuid'].'</th>
	<th align="center">'.$l['st_type'].'</th>
	<th align="center">'.$l['st_format'].'</th>
	<th align="center">'.$l['st_path'].'</th>
	<th align="center">'.$l['st_primary'].'</th>
	<th align="center">'.$l['st_size'].'</th>
	<th align="center">'.$l['st_free'].'</th>
	<th align="center">'.$l['st_oversell'].'</th>
	<th align="center">'.$l['st_alert_threshold'].'</th>
	<th colspan="2">'.$l['manage'].'</th>
	<th class="z-index-1 min_width">
		'.get_checkbox('select_all', '', 'select_all', array('chk_it' => 0), '', 'select_all').'
	</th>
</tr>';
	foreach($storage as $k => $v){
echo '<tr>
	<td>'.$v['stid'].'</td>
	<td>'.$v['name'].' <a href="'.$globals['index'].'act=storageusage&st_name='.$v['name'].'&search=Search" target="_blank"><i class="fas fa-external-link-alt"></i></a></td>
	<td>'.@implode(", ", $ipgp[$v['stid']]).'</td>
	<td>'.$v['st_uuid'].'</td>
	<td><script>document.write(storageflare["'.storage_type_text($v['type']).'"])</script>'.storage_type_text($v['type']).'</span></td>
	<td><span class="text-monospace">'.$v['format'].'</span></td>
	<td><span class="text-monospace">'.$v['path'].'</span></td>
	<td>'.(empty($v['primary_storage']) ? $l['no'] : $l['yes']).'</td>
	<td>'.$v['size'].' GB</td>
	<td>'.$v['free'].' GB</td>
	<td>'.$v['oversell'].' GB</td>
	<td>'.$v['alert_threshold'].'%</td>
	<td><a href="?act=editstorage&stid='.$v['stid'].'" title="Edit"><i class="fas fa-edit text-warning"></i></a></td>
	<td><a href="javascript:void(0);" onclick="return Delstorage('.$k.');" title="Delete"><i class="fas fa-trash text-danger"></i></td>
	<td width="20" valign="top" align="center">
		'.get_checkbox('storage_list[]', '', '', array('chk_it' => 0), $k).'
	</td>
	</tr>';
	}
echo '</table>
</div>';
echo'<div class="row mx-auto w-100 mt-5">
	<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
		page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
	echo'
	</div>
	<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3">
		<div class="bottom-menu float-right w-100">
            <div class="row my-auto">
                <div class="p-0">
                    <label>'.$l['with_selected'].'</label>
                </div>
                <div class="col p-0">
					<select name="storage_task_select" id="storage_task_select" class="custom-select">
						<option value="0">---</option>
						<option value="1">'.$l['ms_delete'].'</option>
					</select>
                </div>
                <div class="pl-2">
					<input type="submit" id ="storage_submit" class="go_btn" name="storage_submit" value="'.$l['go'].'" onclick="Delstorage(0, this); return false;">
                </div>
            </div>
		</div>
	</div>
</div>
</form>

<div id="progress_bar" style="display:none;">
	<br />
	<center>
		<font id="progress_txt" size="4">'.$l['action_msg'].'</font>
	</center>
	<div class="my-2" align="center">
		<div class="progress w-50">
			<div class="progress-bar bg-primary progress-bar-striped progress-bar-animated w-100">
			</div>
		</div>
	</div>
	<center>
		'.$l['notify_msg'].'
	</center>
</div>
<center>
<a href="index.php?act=addstorage" class="link_btn">'.$l['add_storage'].'</a>
</center></div><br>';

}
echo '</div>';
softfooter();

}
?>
