<?php

//////////////////////////////////////////////////////////////
//===========================================================
// config_lang.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       8th Mar 2010
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////
// ----------------------------------------------------------
// Deutsche Übersetzung für VIRTUALIZOR
// ----------------------------------------------------------
// Von: Danny Lotz
// Datum: 22.09.2014
// Web: https://www.1fire.de
// ===========================================================
///////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

$l['no_sn'] = 'Es wurde kein Seitenname angegeben.';
$l['no_cookie_name'] = 'Es wurde kein Cookie-Name angegeben';
$l['invalid_cookie_name'] = 'Sie haben einen ungültigen Cookie-Namen angegeben';
$l['no_soft_email'] = 'Es wurde keine E-Mail-Adresse angegeben';
$l['wrong_soft_email'] = 'Die angegebene E-Mail-Adresse ist ungültig';
$l['no_lang'] = 'Es wurde keine Sprache ausgewählt';
$l['wrong_lang'] = 'Die gewählte Sprache ist ungültig';
$l['no_theme_folder'] = 'Es wurde kein Theme ausgewählt';
$l['wrong_theme_folder'] = 'Das ausgewählte Theme ist ungültig';
$l['no_timezone'] = 'Es wurde keine Zeitzone ausgewählt';
$l['wrong_timezone'] = 'Die gewählte Zeitzone ist ungültig';
$l['no_cron_time'] = 'Es wurde keine Cron-Job Zeit angegeben';
$l['no_emps_cron_time'] = 'Es wurde keine Cron-Job Zeit für EMPS angegeben. EMPS ist das Virtualizor Paket von nginx, PHP und MySQL';
$l['no_off_message'] = 'Es wurde kein Ausschalten Betreff angegeben';
$l['no_off_subject'] = 'Es wurde keine Ausschalten Nachricht angegeben';
$l['saving_error'] = 'Es gab einige Fehler beim Speichern der Einstellungen';
$l['no_dbhost'] = 'Kein Host angegeben';
$l['no_db'] = 'Keine Datenbank angegeben';
$l['no_dbuser'] = 'Kein Datenbank Benutzer angegeben';
$l['no_dbpass'] = 'Kein Datenbank Passwort angegeben';
$l['no_theme'] = 'Kein Theme angegeben';
$l['no_admin_logs'] = 'Die Admin-Protokoll Dauer wurde nicht angegeben';
$l['no_vps_logs'] = 'Die '.VM_SHORT.' und Benutzer-Protokoll Dauer wurde nicht angegeben';
$l['no_login_logs'] = 'Die Login-Protokoll Dauer wurde nicht angegeben';
$l['no_system_logs'] = 'Die '.VM_SHORT.' System-Protokoll Dauer wurde nicht angegeben';
$l['no_status_logs'] = 'Die '.VM_SHORT.' Status-Protokoll Dauer wurde nicht angegeben';
$l['no_bandwidth_logs'] = 'Die Datenverkehr-Protokoll Dauer wurde nicht angegeben';
$l['no_sess_len'] = 'Die Sitzungs-Länge wurde nicht gegeben';
$l['invalid_update'] = 'Eine ungültige Update Präferenz wurde angegeben';
$l['no_xen_dom0mem'] = 'Bitte geben Sie den Domain-0 Arbeitsspeicher an';
$l['invalid_xen_dom0mem'] = 'Der Domain-0 Arbeitsspeicher sollte nicht kleiner als 512 MB sein';
$l['no_vg'] = 'Bitte geben Sie die Volume Group (VG) an';
$l['inv_vg'] = 'Die angegebene Volume Group existiert nicht.';
$l['login_attempts_invalid'] = 'Die <b>Max Anmeldeversuche</b> kann nicht weniger als 2 sein';
$l['login_ban_time_invalid'] = 'Die <b>fehlgeschlagene Login-Ban Zeit</b> kann nicht weniger als 2 sein';
$l['invalid_disk_limit'] = 'Ein ungültiges Festplatten Limit wurde angegeben';
$l['vnc_ip'] = 'VNC IP setzen';
$l['vnc_ip_exp'] = 'Verwenden Sie diese Option nur, wenn Virtualizor in einem internen Netzwerk installiert ist';
$l['wrong_vnc_ip'] = 'Bitte geben Sie eine gültige IP für VNC an';
$l['ping_ip'] = 'Ping IP setzen';
$l['ping_ip_exp'] = 'Wenn das Virtualizor Bridge Netzwerk gestartet ist, wird es versuchen, an diese IP einen Ping zu senden, um zu überprüfen, ob der Server Konnektivität hat. Wenn leer, dann wird Virtualizor 4.2.2.1 anpingen';
$l['wrong_ping_ip'] = 'Bitte geben Sie eine gültige Ping IP an';
$l['inv_overcommit_val'] = 'Sie können den Wert für den zu überbuchenden Arbeitsspeicher nicht kleiner als den tatsächlichen Arbeitsspeicher angeben';
$l['overcommit'] = 'Arbeitsspeicher überbuchen';
$l['overcommit_exp'] = 'Wenn der gesamte RAM für alle '.VM_SHORT.' auf dem physischen Server angegeben wird, können diese diesen Wert nicht überschreiten.';
$l['slave_cant'] = 'Master-Einstellungen Fehler';
$l['slave_cant_exp'] = 'Slave-Server dürfen die Master-Einstellungen nicht bearbeiten!';


//THEME Settings
$l['<title>'] = 'Konfiguration';
$l['heading'] = 'Konfiguration';
$l['done'] = 'Die Konfiguration wurde geändert.';
$l['dbhost'] = 'Datenbank-Host';
$l['database'] = 'Datenbank-Name';
$l['dbuser'] = 'Datenbank-Benutzer';
$l['dbpass'] = 'Datenbank-Passwort';
$l['sitename'] = 'Seitenname';
$l['cookie_name'] = 'Cookie-Name';
$l['sitename_exp'] = 'Der Name des Servers oder Unternehmens, dass Virtualizor nutzt. Es wird auf vielen Seiten des Virtualizor Webinterface angezeigt.';
$l['master_name'] = 'Master Server Name';
$l['master_name_exp'] = 'If set, then Master server will be show as provided name instead of localhost';
$l['copy_right'] = 'Copyright';
$l['copy_right_exp'] = 'Das Copyright was im Footer erscheint';
$l['cook_name_exp'] = 'Der Name des Cookies, der im Browser gespeichert wird.';
$l['comp_output'] = 'Ausgabe Komprimieren';
$l['comp_output_exp'] = 'Dies komprimiert die Ausgabe und spart eine menge an Datenverkehr';
$l['cpu_nm'] = 'CPU-Modell anzeigen';
$l['cpu_nm_exp'] = 'Zeigt den CPU-Modellnamen in allen '.VM_SHORT.' an.';
$l['choose_lang'] = 'Sprache wählen';
$l['choose_lang_exp'] = 'Wählen Sie Ihre bevorzugte Sprache';
$l['choose_theme'] = 'Theme wählen';
$l['choose_theme_exp'] = 'Das ausgewählte Theme wird das Standard-Theme für Virtualizor';
$l['soft_email'] = 'E-Mail-Addresse';
$l['soft_email_exp'] = 'Die E-Mail-Adresse für die FROM-Header.';
$l['from_email'] = 'From email Address';
$l['from_email_exp'] = 'Set this if you want to set different From Email header. If blank then Email Address will be set as From Header';
$l['timezone'] = 'Zeitzone';
$l['saveconfig'] = 'Konfiguration speichern';
$l['cron_time'] = 'Cron Job Frequenz';
$l['cron_time_exp'] = 'Der Cron-Job, der alle Informationen von den '.VM_SHORT.' sammelt und auch nach neuen Aktualisierungen sucht.';
$l['emps_cron_time'] = 'EMPS Cron Job Frequenz';
$l['emps_cron_time_exp'] = 'Der EMPS cron-Job, der das EMPS Paket von PHP, MySQL und Nginx aktualsiert. Wir empfehlen, diesen zwei Mal im Monat auszuführen.';
$l['logo_url'] = 'Logo URL';
$l['logo_url_exp'] = 'Die empfohlene Größe beträgt 172 x 35 Pixel. Wenn das Feld leer bleibt, wird das Virtualizor-Logo angezeigt';
$l['admin_mob_logo_url'] = 'Mobile Logo URL';
$l['admin_mob_logo_url_exp'] = 'The recommended size is 45 x 53 pixels. If empty the Virtualizor logo will be shown.';
$l['gen_set'] = 'Allgemeine Einstellungen';
$l['data_set'] = 'Datenbankeinstellungen';
$l['updatesettings'] = 'Update-Einstellungen';
$l['email_upd_soft'] = 'Benachrichtigung für Aktualisierungen'; 
$l['email_upd_soft_exp'] = 'Sendet eine E-Mail, wenn eine neue Version für Virtualizor verfügbar ist oder die automatische Aktualisierung durchgeführt wurde.';
$l['email_upd_soft_client'] = 'Benutzer E-Mails deaktivieren'; 
$l['email_upd_soft_client_exp'] = 'Wenn ein neuer '.VM_SHORT.' erstellt wird, wird keine E-Mail an den Benutzer gesendet';
$l['auto_upd_virtualizor'] = 'Automatische Aktualisierung für Virtualizor';
$l['auto_upd_virtualizor_exp'] = 'Wenn aktiviert, wir sich Virtualizor automatisch auf die neueste Version aktualisieren.<br />Die <b>stabile</b> Version wird veröffentlicht, nachdem der Release Candidate gründlich getestet wurde. <br />Der <b>Release Candidate</b> enthält die neueste Version und Features.';
$l['never_update'] = 'Niemals aktualisieren';
$l['stable'] = 'Stabil (empfohlen)';
$l['release_cand'] = 'Release Candidate (Experimentell!)';
$l['logs_settings'] = 'Protokoll Einstellungen';
$l['admin_logs'] = 'Dauer der Admin Protokolle';
$l['admin_logs_exp'] = 'Admin Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
$l['vps_logs'] = 'Dauer der '.VM_SHORT.' Protokolle';
$l['vps_logs_exp'] = VM_SHORT.' Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
$l['login_logs'] = 'Dauer der Login Protokollen';
$l['login_logs_exp'] = 'Login Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
$l['system_logs'] = 'Dauer der '.VM_SHORT.' System Protokolle';
$l['system_logs_exp'] = 'Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
$l['status_logs'] = 'Dauer der '.VM_SHORT.' Status Protokolle';
$l['status_logs_exp'] = 'Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
$l['bandwidth_logs'] = 'Dauer der Datenverkehr Protokolle';
$l['bandwidth_logs_exp'] = 'Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
$l['sess_len'] = 'Session Timeout';
$l['sess_len_exp'] = 'Sekunden, bevor eine ungenutzte Sitzung beendet wird';
$l['update_settings'] = 'Update-Einstellungen';
$l['interface'] = 'Netzwerkschnittstelle';
$l['interface_exp'] = 'Die öffentliche Netzwerkschnittstelle des Servers. Wenn das Feld leer gelassen wird, dann wird <strong>eth0</strong> als Standard-Schnittstelle übernommen.';
$l['xen_settings'] = 'Xen-Einstellungen';
$l['xen_pvbridge'] = 'Paravirtualization Bridge';
$l['xen_pvbridge_exp'] = 'Mit dieser Einstellung können Sie die Standard BRIDGE der Xen PV '.VM_LONG.' definieren.';
$l['xen_hvmbridge'] = 'HVM Bridge';
$l['xen_hvmbridge_exp'] = 'Mit dieser Einstellung können Sie die Standard BRIDGE der Xen HVM '.VM_LONG.' definieren.';
$l['xen_dom0mem'] = 'Domain-0 / Host Arbeitsspeicher';
$l['xen_dom0mem_exp'] = 'Bei Xen ist die Domain-0 der physische Server. Hiermit stellen Sie den verfügbaren Arbeitsspeicher für die Domain-0 ein. Der restliche Arbeitsspeicher des physischen Server wird für die '.VM_SHORT.' zur Verfügung gestellt.';
$l['vg'] = 'Volumen Gruppe';
$l['vg_exp'] = 'Die aktuelle Standard Volumen Gruppe, auf der '.VM_SHORT.' erstellt werden. Diese Option ist deaktiviert, wenn bereits ein '.VM_SHORT.' auf der Volumen Gruppe existiert';
$l['security_settings'] = 'Sicherheitseinstellungen';
$l['eu_iso_settings'] = 'Endbenutzer-ISO-Einstellungen';
$l['login_attempts'] = 'Max Anmeldeversuche';
$l['login_attempts_exp'] = 'Die Anzahl der Versuche, die erlaubt sind, bevor eine IP für die angegebene Zeit gemä&szlig; <b>Fehlgeschlagene Login-Ban Zeit</b> gesperrt wird.';
$l['login_ban_time'] = 'Fehlgeschlagene Login-Ban Zeit';
$l['login_ban_time_exp'] = 'Die Zeit in Minuten, die die IP des Benutzers gesperrt werden soll, wenn die Anzahl der <b>Max Anmeldeversuche</b> erreicht wurde';
$l['secure_allowed_ips'] = 'IP-Liste für den Zugriff auf Virtualizor';
$l['secure_allowed_ips_exp'] = 'Liste von IPs, die auf das Admin-Panel von Virtualizor zugreifen dürfen. Wenn diese Option aktiviert ist, können nur diese IP-Adressen auf das Admin-Panel zugreifen. Wenn mehr als eine IP-Adresse vorhanden ist, müssen die IP-Adressen mit \',\' getrennt werden. Wenn es leer gelassen wird, werden keine Beschränkungen auf IP-Adressen angewendet. Unterstützt derzeit nur IPv4-Adressen.';
$l['secure_allowed_ips_inv'] = 'Ungültige IPs geunden in "<b>'.$l['secure_allowed_ips'].'</b>" Feld';
$l['secure_allowed_api_ips'] = 'Allowed IP list to restrict API operations';
$l['secure_allowed_api_ips_exp'] = 'List of IPs which are allowed to perform API operations. If more than one IP, IPs must be seperated by \',\'. If left empty, no restrictions will be imposed. Currently supporting only IPv4 IP';
$l['secure_allowed_api_ips_inv'] = 'Found invalid IPs in "<b>'.$l['secure_allowed_api_ips'].'</b>" field';
$l['notify_settings'] = 'Benachrichtigungen einstellen';
$l['alert_load_limit'] = 'Alarm bei hoher Last';
$l['alert_load_limit_exp'] = 'Wenn die <b>15 Minuten</b> load des Servers die hier festgelegte Grenze überschreitet, wird eine E-Mail an den Administrator gesendet.';
$l['alert_disk_limit'] = 'Alarm bei Festplatten Limit';
$l['alert_disk_limit_exp'] = 'Wenn die Festplattenbelegung des Server den eingestellten Grenzwert (in %) überschreitet, wird eine E-Mail an den Administrator gesendet.';
$l['openvz_settings'] = 'OpenVZ-Einstellungen';
$l['vswap'] = 'VSwap aktivieren';
$l['vswap_exp'] = 'VSwap für diesen Server aktivieren. Dies wird nur wirksam, wenn das Betriebssystem des Hostservers RHEL/SL/CentOS 6 ist. <br />Weitere Informationen finden Sie unter <a href="'.$globals['docs'].'VSwap_Openvz" target="_blank">diesem</a> Artikel.';
$l['enduser_settings'] = 'Einstellungen Endkunden';
$l['disable_icons_monitor'] = 'überwachung deaktivieren';
$l['disable_icons_monitor_exp'] = 'Deaktiviert das Monitor-Symbol für den Endkunden';
$l['disable_icons_cp'] = 'Control Panel deaktivieren';
$l['disable_icons_cp_exp'] = 'Deaktiviert das Control Panel Installationssymbol für den Endkunden';
$l['disable_recipes'] = 'Rezepte deaktivieren';
$l['disable_recipes_exp'] = 'Rezepte im Kundenbereich deaktivieren';
$l['node_bandwidth'] = 'Hostserver Datenverkehr';
$l['node_bandwidth_exp'] = 'Der gesamte Datenverkehr des Hostservers in GB. Wenn auf null gesetzt, wird für die Berechnung des Datenverkehrs unbegrenzter Datenverkehr benutzt';
$l['vps_bandwidth_threshold'] = VM_SHORT.' Benachrichtigung für Traffic Limit';
$l['vps_bandwidth_threshold_exp'] = 'Wenn dieser Wert auf 0 eingestellt wird, folgt keine E-Mail Benachrichtigung. Wert in %';
$l['change_ssh_port'] = 'SSH-Port ändern';
$l['change_ssh_port_exp'] = 'Stellen Sie den SSH-Port für Ihren Server ein. Es wird empfohlen, zur besseren Sicherheit den Port zu ändern.';
$l['ssh_port_invalid'] = 'Bitte geben Sie einen gültigen SSH-Port an';
$l['max_ssh_login'] = 'Maximale SSH-Logins';
$l['max_ssh_login_exp'] = 'Stellen Sie die maximalen SSH Login-Versuche ein';
$l['ssh_login_invalid'] = 'Bitte geben Sie eine gültige Zahl für die maximalen Anmeldeversuche über SSH an';
$l['overcommit_check'] = 'Arbeitsspeicher überbuchen erlauben';
$l['overcommit_check_exp'] = '<b>Hinweis :</b>Dies kann Ihre '.VM_SHORT.' Leistung beeinträchtigen.';
$l['support'] = 'Support URL';
$l['support_exp'] = 'Geben Sie eine Support-URL an, die im Kundenbereich angezeigt wird.';
$l['enable_tuntap_cp'] = 'Tun/Tap Einstellungen für Endkunden aktivieren';
$l['enable_tuntap_cp_exp'] = 'Standard: Tun/Tap deaktiviert.';
$l['enable_ppp_cp'] = 'PPP Einstellungen für Endkunden aktivieren';
$l['enable_ppp_cp_exp'] = 'Standard: PPP deaktiviert.';
$l['enable_enduser_vnc'] = 'VNC-Verwaltung erlauben';
$l['enable_enduser_vnc_exp'] = 'Wenn aktiviert, kann der Benutzer VNC für seinen '.VM_SHORT.' aktivieren / deaktivieren';
$l['hide_enuser_vnc_info'] = 'Hide VNC details';
$l['hide_enuser_vnc_info_exp'] = 'If enabled, VNC details of the '.VM_SHORT.' will not be displayed to enduser';
$l['show_server'] = 'Servername/Standort anzeigen';
$l['show_server_exp'] = 'Wenn aktiviert, können Kunden den Servername oder Standort des '.VM_SHORT.' sehen';
$l['band_suspend'] = 'Datenverkehr Aussetzung deaktivieren';
$l['band_suspend_exp'] = 'Globale Einstellung, um die Datenverkehr Aussetzung für alle '.VM_SHORT.' zu deaktivieren';
$l['speed_cap_disable'] = 'Begrenzung der Netzwerkgeschwindigkeit deaktivieren';
$l['speed_cap_disable_exp'] = 'Globale Einstellung zum Deaktivieren der Begrezung der '.VM_SHORT.'-Netzwerkgeschwindigkeit';
$l['bw_calculation'] = 'Bandwidth Calculation';
$l['bw_calculation_exp'] = 'Bandwidth calculation based on upload/download';
$l['bw_cal_upload'] = 'Bandwidth calculation for upload only. Total usage will be shown for upload only.'; 
$l['bw_cal_download'] = 'Bandwidth calculation for download only. Total usage will be shown for download only.';
$l['bw_cal_both'] = 'Normal Bandwidth calculation. Total usage will be shown as sum of upload and download.';
$l['novnc_settings'] = 'noVNC Einstellungen';
$l['novnc'] = 'noVNC aktivieren';
$l['novnc_exp'] = 'Diese Option wird den HTML5 VNC-Viewer zusammen mit dem JAVA VNC Viewer aktivieren ';
$l['novnc_master_only'] = 'Nur Master Proxy';
$l['novnc_master_only_exp'] = 'Wenn aktiviert, hat nur der Master den noVNC Websocket Service';
$l['novnc_server_name'] = 'Server Hostname verwenden';
$l['novnc_server_name_exp'] = 'Wenn aktiviert, dann wird der Name des Servers (anstelle der IP) als Host benutzt, um auf den noVNC Dienst zuzugreifen. Bitte stellen Sie sicher, dass der Name des Servers im Master korrekt ist.';
$l['disable_login_logo'] = 'Login Logo deaktivieren';
$l['exp_disable_login_logo'] = 'Wenn diese Option aktiviert ist, wird das Logo bei der Anmeldung für die Endkunden ausgeblendet werden. Dies ist nützlich, um Resellern oder Cloud-Benutzern zu helfen, das System als ihr eigenes auszugeben.';
$l['disable_backup_cp'] = 'Backup deaktivieren für den Kundenbereich';
$l['disable_backup_cp_exp'] = 'Standardgemä&szlig; wird das Backup-Symbol angezeigt.';
$l['disable_java_vnc'] = 'JAVA VNC Viewer deaktivieren';
$l['disable_java_vnc_exp'] = 'Diese Option deaktiviert den JAVA VNC Viewer';
$l['pass_strength'] = 'Standard-Passwort-Stärke';
$l['pass_strength_exp'] = 'Wenn gesetzt, werden die Benutzer gezwungen, das Passwort der spezifischen Stärke festzulegen';
$l['inv_pass_limit'] = 'Kennwortstärke sollte nicht mehr als 100 sein';
$l['enable_fuse_cp'] = 'FUSE-Einstellungen für Endkunden aktivieren';
$l['enable_fuse_cp_exp'] = 'Standard: FUSE deaktiviert.';
$l['enable_ipip_cp'] = 'IPIP-Einstellungen für Endkunden aktivieren';
$l['enable_ipip_cp_exp'] = 'Standard: IPIP deaktiviert.';
$l['enable_ipgre_cp'] = 'IPGRE-Einstellungen für Endkunden aktivieren';
$l['enable_ipgre_cp_exp'] = 'Standard: IPGRE deaktiviert.';
$l['enable_nfs_cp'] = 'NFS-Einstellungen für Endkunden aktivieren';
$l['enable_nfs_cp_exp'] = 'Standard: NFS deaktiviert.';
$l['enable_quotaugidlimit_cp'] = 'QUOTAUGIDLIMIT-Einstellungen für Endkunden aktivieren';
$l['enable_quotaugidlimit_cp_exp'] = 'Standard: QUOTAUGIDLIMIT deaktiviert.';
$l['enable_iolimit_cp'] = 'IO Bandbreiten-Limit-Einstellungen für Endkunden aktivieren';
$l['enable_iolimit_cp_exp'] = 'Standard: IO-Bandbreite deaktiviert.';
$l['enable_iopslimit_cp'] = 'IOPS-Limit-Einstellungen für Endkunden aktivieren';
$l['enable_iopslimit_cp_exp'] = 'Standard: IOPS-Limit deaktiviert.';
$l['favicon_url'] = 'Favicon URL';
$l['favicon_url_exp'] = 'If not set then Virtualizor favicon will be used';
$l['enable_backup_delete'] = 'Delete Backup on '.VM_SHORT.' deletion';
$l['enable_backup_delete_exp'] = 'If checked Backup will get deleted on '.VM_SHORT.' deletion.';
$l['enable_backup_delete_cron'] = 'Number of days';
$l['enable_backup_delete_cron_exp'] = 'If it is zero '.VM_SHORT.' Backup will get deleted immediately on '.VM_SHORT.' deletion.<br>Or it will get deleted after provided number of days.';
$l['disable_virtsparsify'] = 'Disable virt-sparsify';
$l['disable_virtsparsify_exp'] = 'If checked, '.VM_SHORT.' will not be sparsed after every Start/Poweroff operation';
$l['disable_2tb_check'] = 'Disable 2TB check for '.VM_SHORT;
$l['disable_2tb_check_exp'] = 'If checked, '.VM_SHORT.' creation of size greater than 2TB will be allowed';
$l['set_vps_config_mtu'] = 'Set MTU value in '.VM_SHORT.' config file';
$l['set_vps_config_mtu_exp'] = 'If enabled, then MTU value will be set in '.VM_SHORT.' config file for supported Virtualizations';
$l['disable_terminal_access'] = 'Disable Server Web Terminal';
$l['disable_terminal_access_exp'] = 'If enabled, server web terminal access will be disabled from the Admin panel';
$l['domain_forwarding_check'] = 'Disable domain forwarding for enduser';
$l['domain_forwarding_check_exp'] = 'If checked, Domain Forwarding feature will be disabled from enduser panel';
$l['disable_domain_forward'] = 'Domain Forwarding is disabled';
$l['show_vps_active_time'] = 'Show '.VM_SHORT.' active hours in enduser panel';
$l['show_vps_active_time_exp'] = 'If checked, Enduser panel will show '.VM_SHORT.' Up time';
$l['power_only_option'] = 'Show Power buttons only';
$l['power_only_option_exp'] = 'If enabled, then user will only get power option(s) while accessing enduser panel. All other options will be disabled. <b>NOTE:</b> This setting will be applied ONLY when <b>Managed By Admin</b> is enabled.';
$l['disable_logs'] = 'Disable Logs';
$l['disable_logs_exp'] = 'If enabled then enduser will not be able to see Logs Tab';
$l['disable_change_primary_ip'] = 'Disable Change of Primary IP';
$l['disable_change_primary_ip_exp'] = 'If enabled then enduser will not be able to change primary IP of '.VM_SHORT;
$l['vz6_style_suspend'] = 'Use <b>vzctl suspend</b> for virtuozzo CT';
$l['vz6_style_suspend_exp'] = 'If enabled then virtuozzo container will be suspended using vzctl command';
$l['enable_iops_sec'] = 'Allow Total I/O per sec';
$l['enable_iops_sec_exp'] = 'If enabled then cloud user will be able to set I/O limit';
//Enable Enduser ISO
$l['enable_eu_iso'] = 'ISO-Option für Endbenutzer aktivieren';
$l['enable_eu_iso_exp'] = 'Wenn aktiviert, können die Endbenutzer ihre eigenen ISOs aus dem Kunden Panel hinzufügen';
$l['eu_iso_size'] = 'Max. ISO-Größe (MB)';
$l['eu_iso_size_exp'] = 'Geben Sie die maximale Größe einer ISO-Datei an, die ein Endbenutzer herunterladen kann. Wenn nicht angegeben, wird 5120 MB als Standardgröße eingestellt.';
$l['eu_iso_limit'] = 'Anzahl der zulässigen ISOs';
$l['eu_iso_limit_exp'] = 'Geben Sie die Anzahl der ISOs an, die ein Endbenutzer herunterladen kann. Wenn nicht angegeben, wird 3 als Standardgrenze gesetzt.';
$l['eu_iso_space'] = 'Speicherpatz insgesamt für ISOs/Endbenutzer (MB)';
$l['eu_iso_space_exp'] = 'Der Gesamtspeicherplatz für ISOs der pro Endbenutzer erlaubt ist. Wenn nicht angegeben, wird 5120 MB als Standard Speicherplatz gesetzt.';
$l['inv_eu_iso_limit'] = 'Endbenutzer ISO-Einstellungen können keine negativen oder leeren Werte haben';
$l['eu_iso_del_hr'] = 'Endbenutzer-ISO automatisch löschen (Stunden)';
$l['eu_iso_del_hr_exp'] = 'Wenn angegeben, werden Endbenutzer-ISOs nach bestimmten Stunden gelöscht';
$l['eu_iso_del_hr_err'] = 'Der Wert für das automatisch Löschen kann nicht negativ sein';
$l['enable_eu_iso_boot'] = 'Enable Enduser ISO Boot';
$l['enable_eu_iso_boot_exp'] = 'If checked, enduser(s) will be able to boot '.VM_SHORT.' from ISO';
$l['enable_eu_iso_error'] = 'Please Enable Enduser ISO BOOT to use ISO Option for Enduser';

// HAProxy Config Langs
$l['haproxy_settings'] = 'HAProxy-Einstellungen ('.VM_SHORT.' Domainweiterleitung)';
$l['haproxy_enable'] = 'HAProxy aktivieren';
$l['haproxy_enable_exp'] = 'Dies ermöglicht es, '.VM_SHORT.' Dienste auf privaten IPs zu hosten, auf die über das Internet zugegriffen werden kann';
$l['haproxy_src_ips'] = 'HAProxy Quell-IPs';
$l['haproxy_src_ips_exp'] = 'Komma getrennte Liste von IPs, auf denen Proxy auf diesem Server zugelassen werden darf. Wenn leer, wird die primäre IP des Slave-Server verwendet.<br/>Hinweis: Das Ändern von Quell-IPs erfordert auch die Neuzuordnung von alten Quell-IPs mit neuen unter Admin-Panel > Virtuelle Server > Domainweiterleitung > Server-Seite, um vorhandene VDF-Datensätze mit neuen Quell-IPs zu aktualisieren';
$l['haproxy_src_ips_inv'] = 'Ungültige IPs in der Liste der für HAProxy angegebenen IPs gefunden';
$l['haproxy_src_ips_change'] =  'Das Ändern von Quell-IPs erfordert auch die Neuzuordnung von alten Quell-IPs mit neuen unter Admin-Panel > Virtuelle Server > Domainweiterleitung > Server-Seite, um vorhandene VDF-Datensätze mit neuen Quell-IPs zu aktualisieren';

$l['haproxy_reservedports'] = 'HAProxy blockierte Ports';
$l['haproxy_reservedports_exp'] = 'Liste der Quell-Ports, die für HAProxy nicht erlaubt sind. Mehrere Ports sollten mit \',\' getrennt werden und der Portbereich muss mit  \'-\' angegeben werden (z.B: 26,99,1001-1005).';
$l['haproxy_reservedports_inv'] = 'Ungültige Ports in der Liste der reservierten Ports, die für HAProxy angegeben sind gefunden';

$l['haproxy_reservedports_http'] = 'HAProxy reservierte Ports nur für HTTP(S)';
$l['haproxy_reservedports_http_exp'] = 'Liste der Quell-Ports, die für HAProxy reserviert sind, um nur für das HTTP und HTTPS-Protokoll verwendet zu werden, d.h diese Ports werden für keine TCP-Ports in HAProxy zugelassen. Mehrere Ports sollten durch \',\' getrennt werden und der Portbereich muss mit \'-\' angegeben werden (z.B: 26,99,1001-1005).';
$l['haproxy_reservedports_http_inv'] = 'Ungültige Ports in der Liste der HAProxy HTTP(S) reservierten Ports';
$l['haproxy_reservedports_http_restricted'] = 'Ports in der Liste der HAProxy HTTP(S) reservierten Ports gefunden';

$l['haproxy_allowedports'] = 'HAProxy zulässige Ports für HTTP(S) und TCP';
$l['haproxy_allowedports_exp'] = 'Liste der Quel-Ports, die für jedes Protokoll für HAProxy verwendet werden dürfen. Wenn leer, wird jeder verfügbare Port dem Benutzer erlaubt. <b>Hinweis</b> : Wenn angegeben, werden HTTP- und TCP-Ports nur von diesen Port(s) erlaubt. Mehrere Ports sollten durch \',\' getrennt werden und der Portbereich muss mit \'-\' angegeben werden (z.B: 26,99,1001-1005).';
$l['haproxy_allowedports_inv'] = 'Ungültige Ports in der Liste der erlaubten HAProxy-Ports gefunden';
$l['haproxy_allowedports_restricted'] = 'Eingeschränkte Ports in der Liste der erlaubten HAProxy-Ports gefunden';
$l['haproxy_allowedports_http'] = 'Die für HTTP(S) reservierten Ports fehlen aus der Liste der erlaubten HAProxy-Ports';

$l['haproxy_empty_src_ips'] = 'HAProxy '.VM_SHORT.' Domainweiterleitung aktiviert, aber Quell-IP List ist leer';

$l['haproxy_cron_logs'] = 'Dauer der HAProxy Protokolle';
$l['haproxy_cron_logs_exp'] = 'Protokolle, die älter als die angegebenen Tage sind, werden gelöscht (Geben Sie 0 für kein Limit an)';
                              
$l['no_haproxy_cron_logs'] = 'Der HAProxy Cron zur Aufbewahrung der Protokolle wurde nicht angegeben';

// Addvs IO/CPU priority settings
$l['addvs_io_cpu_settings'] = VM_SHORT.' IO/CPU-Priorität einstellen';
$l['nice'] = 'Prozess-Priorität';
$l['nice_exp'] = 'Die Menge der CPU-Zeit, die der '.VM_SHORT.'-Erstellungsprozess erhält. Werte von 19 (niedrige Priorität) bis -20 (hohe Priorität)';
$l['ionice_class'] = 'Prozess I/O Klasse';
$l['ionice_class_exp'] = 'I/O Klasse für den '.VM_SHORT.'-Erstellungsprozess';
$l['ionice_prio'] = 'Prozess I/O Priorität';
$l['ionice_prio_exp'] = 'I/O Priorität für den '.VM_SHORT.'-Erstellungsprozess. Werte von 0 (hohe Priorität) bis 7 (niedrige Priorität)';
$l['addvs_io_cpu_note'] = 'Sie müssen alle drei Werte gesetzt haben, damit dies beim erstellen des '.VM_SHORT.' genutzt wird';

// Queue Creation Notification
$l['queue_creation'] = 'Warteschlange aktiveren';
$l['queue_creation_exp'] = 'Wenn Sie z. B. den Wert auf 2 setzen, dann werden nur 2 '.VM_SHORT.' gleichzeitig erstellt. Andere Erstellungsprozesse werden zur Warteschlange hinzugefügt';

// MAC Address Initial Digits
$l['custom_mac'] = 'Benutzerdefinierte MAC-Präfix';
$l['custom_mac_exp'] = 'Initial 3 Oktett für automatisch generierte MAC-Adressen von '.VM_SHORT.'. Wenn nicht gesetzt, wird der Standardwert 00:16:3e verwendet';
$l['invalid_mac'] = 'Die initial eingegebenen 3 Oktett der MAC sind ungültig';
$l['inv_multicast_mac'] = 'MAC-Initialen gefunden, um Multicast zu sein, erwartet Unicast MAC. Bitte geben Sie eine gerade Zahl in LSByte des ersten Oktetts an';

$l['vps_limit'] = 'Limit für die '.VM_SHORT.'-Erstellung';
$l['vps_limit_exp'] = 'Diese Konfiguration ist dafür da, die Anzahl der '.VM_SHORT.', die auf diesem Server erstellt werden sollen zu beschränken. 0 setzen für keine Beschränkung.';

$l['set_def_hvm'] = 'Verwenden Sie HVM als Standard';
$l['set_def_hvm_exp'] = 'Wählen Sie diese Option, um HVM als Standard für die '.VM_SHORT.'-Erstellung auf unterstützten Hypervisoren festzulegen';

$l['ploop'] = 'Ploop';
$l['ploop_exp'] = 'Ploop wird für alle neu erstellten '.VM_SHORT.' aktiviert.';

$l['pv_on_hvm'] = 'PV-on-HVM';
$l['pv_on_hvm_exp'] = 'Globale Einstellung um PV-on-HVM für alle neuen VMs zu aktivieren';

$l['band_calc_creation'] = 'Datenverkehr nach Abrechnungszeitraum berechnen';
$l['band_calc_creation_exp'] = 'Diese Option wird den Datenverkehr nach dem '.VM_SHORT.' Abrechnungszeitraum berechnen. Wenn der '.VM_SHORT.' z.B. am 15. Januar erstellt wurde, wird der Datenverkehr vom 15. Januar bis 14. FEBRUAR berechnet.';

$l['enable_rdns'] = 'RDNS aktivieren';
$l['enable_rdns_exp'] = 'Wenn ausgewählt, wird Reverse-DNS für alle '.VM_SHORT.' eingeschaltet. Allerdings müssen Sie einen DNS-Server einrichten.';

$l['master_setting_note'] = '<b>HINWEIS</b> : Diese Einstellungen sind globale Einstellungen, die für alle Slave-Server synchronisiert werden. Sie können die Einstellungen auch auf einer pro Hostserver Basis mit dem  <a href="'.$globals['index'].'act=config_slave">Slave-Einstellungsassistenten</a> durchführen.';
$l['slave_setting_note'] = '<b>HINWEIS</b> : Diese Einstellungen sind individuelle Einstellungen für den aktiven Server. Diese Einstellungen werden die Master-Einstellungen auf dem aktiven Slave Server überschreiben.';

$l['use_xl'] = 'XL verwenden';
$l['use_xl_exp'] = 'Benutzen das <b>xl</b> Tool anstelle des veralteten <b>xm</b> Tool. HINWEIS: Der xend Dienst muss heruntergefahren werden, und an einem neuen Start gehindert werden';
$l['auto_add_zone'] = 'Auto hinzufügen rDNS Zone';
$l['auto_add_zone_exp'] = 'Wenn aktiviert, werden die RDNS Zonen automatisch für Datensätze deren Zone nicht vorhanden ist erstellt';
$l['disable_apicredential'] = 'Deaktivieren des Zugriff für die API Anmeldeinformationen im Client-Panel';
$l['exp_disable_apicredential'] = 'Wenn aktiviert, können Kunden keine API-Anmeldeinformationen generieren.';
$l['enable_console'] = 'Aktivieren der seriellen Konsole';
$l['enable_console_exp'] = 'Serielle Konsole für OpenVZ-Container aktivieren. Warnung: Es wird ein SSH-Benutzer auf dem OpenVZ-Hostserver erstellt, damit diese Funktion genutzt werden kann.';
$l['curl_timeout'] = 'CURL Timeout';
$l['curl_timeout_exp'] = 'Wenn gesetzt, dann wird Virtualizor diesen Wert als CURL Timeout verwenden. Der Standardwert ist 3. Bitte stellen Sie einen Wert über 3 ein, wenn Sie das Zeitlimit ändern möchten.';
$l['del_novps_user'] = 'Benutzer ohne '.VM_SHORT.' löschen';
$l['del_novps_user_exp'] = 'Wenn diese Option aktiviert wird, dann werden alle Benutzer ohne '.VM_SHORT.' täglich gelöscht.';
$l['del_slave_ostemplate'] = 'OS Template auf Slave Server löschen';
$l['del_slave_ostemplate_exp'] = 'Wenn aktiviert, werden alle OS templates von allen Slave-Server gelöscht. Dies ist nützlich, um Speicherplatz auf den Slaves zu sparen. Aber es wird mehr Traffic erfordern, da die Templates jedesmal erneut heruntergeladen werden müssen.';
$l['disable_master_vpsname'] = 'Master '.VM_SHORT.' Name deaktivieren';
$l['disable_master_vpsname_exp'] = 'Standardmä&szlig;ig vergibt der Master die '.VM_SHORT.' Namen und verwendet den höchsten '.VM_SHORT.' Namen im Cluster. Wenn aktiviert, wird der '.VM_SHORT.' Name von jedem einzelnen Slave-Server vergeben.';
$l['showsearch'] = 'Suchfeld anzeigen (standardmä&szlig;ig)';
$l['showsearch_exp'] = 'Wenn aktiviert, werden die Suchfelder auf allen Seiten angezeigt, auf denen eine Suche möglich ist.';
$l['disable_nw_config'] = 'Netzwerkkonfiguration deaktivieren';
$l['exp_disable_nw_config'] = 'Wenn ausgewählt, wird Virtualizor das Netzwerk nicht konfigurieren / neu schreiben, wenn ein '.VM_SHORT.' neu gestartet wird. Bei der Erstellung des '.VM_SHORT.' wird jedoch die Netzwerkdatei geschrieben.';
$l['site_domain'] = 'Seiten Domain';
$l['site_domain_exp'] = 'Wenn leer, wird die Server IP anstelle von der Domain verwendet.';
$l['turnon_virtdf'] = 'Turn On Virt-df';
$l['turnon_virtdf_exp'] = 'If checked, virt-df will be used to get the disk usage in hourly cron, and the disk usage will be detected on startup of individual '.VM_SHORT.'(s).';
$l['disable_newtheme'] = 'Neues Theme deaktivieren';
$l['disable_newtheme_exp'] = 'Wenn aktiviert, können Kunden nicht die neue Benutzeroberfläche verwenden.';
$l['enable_idsort'] = VM_SHORT.' nach ID in absteigender Reihenfolge sortieren';
$l['enable_idsort_exp'] = 'Wenn diese Option aktiviert ist, werden die neusten '.VM_SHORT.' zuerst angezeigt';
$l['eu_allow_virtio'] = 'Virtio Verwaltung erlauben';
$l['eu_allow_virtio_exp'] = 'Wenn aktiviert, können Benutzer virtio für ihre '.VM_SHORT.' aktivieren / deaktivieren';
$l['allow_virtio'] = 'Virtio erlauben';
$l['allow_virtio_exp'] = 'Wenn diese Option aktiviert wird, können Cloud Benutzer virtio für ihre Benutzer zur Verfügung stellen';
$l['disable_rescue'] = 'Rettungsmodus deaktivieren';
$l['disable_rescue_exp'] = 'Deaktivert den Rettungsmodus im Kundenbereich';
$l['disable_change_hostname'] = 'Änderung des Hostnamens deaktivieren';
$l['disable_change_hostname_exp'] = 'Wenn diese Option aktiviert wird, können Kunden den Hostnamen nicht ändern';
$l['disable_change_password'] = 'Änderung des '.VM_SHORT.' Kennwort deaktivieren';
$l['disable_change_password_exp'] = 'Wenn diese Option aktiviert wird, können Kunden das Passwort ihrers '.VM_SHORT.' nicht ändern';
$l['disable_change_vnc_password'] = 'Disable change of '.VM_SHORT.' VNC Password';
$l['disable_change_vnc_password_exp'] = 'Endusers will not be able to change the password of their '.VM_SHORT.'\'s VNC';
$l['disable_vps_config'] = VM_SHORT.'-Konfiguration deaktivieren';
$l['disable_vps_config_exp'] = 'Wenn diese Option aktiviert wird, können Kunden die Einstelllungen des '.VM_SHORT.' nicht ändern';
$l['disable_os_reinstall'] = 'OS neu installieren deaktivieren';
$l['disable_os_reinstall_exp'] = 'Wenn diese Option aktiviert wird, können Kunden das Betriebssystem nicht neu installieren';
$l['disable_ssh'] = 'SSH deaktivieren';
$l['disable_ssh_exp'] = 'Wenn diese Option aktiviert wird, können Kunden nicht vom Kundenbereich aus auf SSH zugreifen';
$l['vcores_limit'] = 'Virtuelle Kerne';
$l['vcores_limit_exp'] = 'Number of virtual cores available for '.VM_SHORT.' creation. Once the limit is reached <br /> -  '.VM_SHORT.'(s) can not be created on this node. <br /> - Additional cores can not be assigned to existing '.VM_SHORT;
$l['disable_suspend_email'] = 'E-Mail bei '.VM_SHORT.' Sperrung deaktivieren';
$l['disable_suspend_email_exp'] = 'Die Kunden erhalten keine E-Mail bei einer Sperrung des '.VM_SHORT;
$l['del_tasks'] = 'Aufgaben Dauer';
$l['del_tasks_exp'] = 'Aufgaben älter als die angegebenen Tage werden gelöscht. (Geben Sie 0 für keine Grenze ein)';
$l['del_notifications'] = 'Notifications Retention';
$l['del_notifications_exp'] = 'Notifications will be saved for the specified number of days. (0 for infinite retention)';
$l['del_api_logs'] = 'API Logs Retention';
$l['del_api_logs_exp'] = 'API Logs will be saved for the specified number of days. (0 for infinite retention)';
$l['disable_self_shutdown'] = 'Geplante Aufgaben deaktivieren';
$l['disable_self_shutdown_exp'] = 'Wenn deaktivert, können Kunden keine Aufgaben für Ihre '.VM_SHORT.' planen';
$l['disable_server_location'] = 'Server-Standort deaktivieren';
$l['disable_server_location_exp'] = 'Wenn deaktiviert, wird der Server-Standort nicht auf der Karte im Kundenbereich angezeigt';
$l['no_del_tasks'] = 'Dauer der Aufgaben wurde nicht angegeben';
$l['enable_nic'] = 'NIC Option aktivieren ';
$l['enable_nic_exp'] = 'Wenn aktiviert, kann der Benutzer die Netzwerkkarte für den '.VM_SHORT.' selber auswählen bzw. ändern';
$l['disable_cloud_suspend_options'] = 'Die Option zum sperren für Cloud Benutzer deaktivieren';
$l['disable_cloud_suspend_options_exp'] = 'Wenn diese Option aktiviert ist, wird die Option zum '.VM_SHORT.' sperren/entsperren und Netzwerkverbindung sperren/entsperren für Cloud Benutzer deaktiviert';
$l['openvz_suspend_load'] = VM_SHORT.' bei hoher Last sperren';
$l['openvz_suspend_load_exp'] = 'Wenn ein Wert eingetragen wurde, dann werden die letzten 5 Minuten jeder '.VM_SHORT.' geprüft und wenn der Wert höher ist, als der von Ihnen eingetragene, dann werden die VMs gesperrt.';
$l['default_sg_name'] = 'Legen Sie den Standard Servergruppennamen fest';
$l['default_sg_name_exp'] = 'Wenn nicht festgelegt, wird Standard als Servergruppe angezeigt, die Standardgemäß von Virtualizor erstellt wird';
$l['default_sg_reseller_name'] = 'Legen Sie den Standardnamen des Reseller-Bereichs fest';
$l['default_sg_reseller_name_exp'] = '(Optional) Der Name der Servergruppe, die den Wiederverkäufern angezeigt wird. Wenn nicht, wird die Voreinstellung gesetzt';
$l['default_sg_desc'] = 'Legen Sie die Standard-Servergruppenbeschreibung fest';
$l['2fa_email_otp'] = 'Email OTP';
$l['2fa_email_otp_exp'] = 'Wenn aktiviert und wenn keine Methode vom Benutzer ausgewählt ist, wird die Zwei-Faktor-Authentifizierung via E-Mail aktiviert.';
$l['enable_2fa'] = 'Aktivieren Sie die Zwei-Faktor-Authentifizierung';
$l['enable_2fa_exp'] = 'Wenn aktiviert, wird die Zwei-Faktor-Authentifizierung für Endbenutzer aktiviert. Aber die Benutzer müssen die Methode, die sie nutzen wollen aus dem Endbenutzer-Panel selber aktivieren.';
$l['keep_orphan_template'] = 'Keine verwaisten OS Vorlagen löschen';
$l['keep_orphan_template_exp'] = 'Wenn ausgewählt, werden verwaiste OS Vorlagen, die in Virtualizor nicht vorhanden sind, nicht gelöscht.';
$l['disable_virttop'] = 'virt-top deaktivieren';
$l['disable_virttop_exp'] = 'Wenn diese Option aktiviert ist, werden Statistiken über CPU und DISK I/O von '.VM_SHORT.' auf unterstützten Hypervisoren nicht angezeigt.';
$l['disable_enduser_sshkeys'] = 'SSH-Schlüssel deaktivieren';
$l['disable_enduser_sshkeys_exp'] = 'Endbenutzer werden nicht in der Lage sein, SSH-Schlüssel zu Ihren '.VM_SHORT.' hinzuzufügen';
$l['disable_vga'] = 'VGA deaktivieren';
$l['disable_vga_exp'] = 'Wenn diese Option aktiviert ist, wird die Option "VGA aktivieren" im Dialogfeld "'.VM_SHORT.'-Konfiguration" im Endbenutzerfenster nicht angezeigt.';
$l['xen_dm_version'] = 'Xen dm version';
$l['xen_dm_version_exp'] = 'Define which value to use for xen_dm_version config of '.VM_SHORT.', qemu-xen-traditional OR qemu-xen. <br>qemu-xen is available after xen version 4.4+';
$l['xen_dm_version_traditional'] = 'Use <b>qemu-xen-traditional</b>';
$l['xen_dm_version_qemu'] = 'Use <b>qemu-xen</b>';
$l['disable_ebtables'] = 'Disable ebtables';
$l['disable_ebtables_exp'] = 'If checked, ebtables rules will not be created on all the servers for '.VM_SHORT.'(s). If you want to remove ebtables rules for existing '.VM_SHORT.'(s) then after enbaling this setting you will need to edit the '.VM_SHORT.'(s) or update network rules for the '.VM_SHORT.'(s).No need to stop or restart the '.VM_SHORT.'(s)';
$l['disable_ebtables_internal'] = 'Disable internal IP ebtables';
$l['disable_ebtables_internal_exp'] = 'If checked, internal IP ebtables rules will not be created on all the servers for '.VM_SHORT.'(s). If you want to remove ebtables rules for existing '.VM_SHORT.'(s) then after enbaling this setting you will need to edit the '.VM_SHORT.'(s) or update network rules for the '.VM_SHORT.'(s).No need to stop or restart the '.VM_SHORT.'(s)';

//Database Settings
$l['database_settings'] = 'Database Settings';
$l['disable_slave_db_backup'] = 'Disable database backup on slave servers';
$l['disable_slave_db_backup_exp'] = 'If checked slave servers will not take database backup';


// Call back Settings 
$l['cb_settings'] = 'Callback Einstellungen';
$l['enable_cb'] = 'Callback aktivieren';
$l['enable_cb_exp'] = 'Wenn diese Option aktiviert ist, werden Änderungen vom Virtualizor Control Panel an Ihr Abrechnungssystem weitergeleitet';
$l['cb_url'] = 'Callback URL';
$l['cb_url_exp'] = 'Die vollständige URL zur Callback-Datei. Wenn Sie z. B. WHMCS verwenden, dann sieht die URL ungefähr so aus billing.xxxx.com/whmcs/modules/servers/virtualizor/callback.php';
$l['cb_hash'] = 'Callback Hash';
$l['cb_hash_exp'] = 'Der Callback Hash wird zur Authentifizierung verwendet';
$l['reset'] = 'Reset Hash';
$l['cb_suspend'] = VM_SHORT.' Sperrung';
$l['cb_suspend_exp'] = 'Wenn ausgewählt, wird der Callback bei Sperrung eines '.VM_SHORT.' aktiviert';
$l['cb_unsuspend'] = VM_SHORT.' Entsperrung';
$l['cb_unsuspend_exp'] = 'Wenn ausgewählt, wird der Callback bei Entsperrung eines '.VM_SHORT.' aktiviert';
$l['cb_hostname'] = VM_SHORT.' Hostname Änderung';
$l['cb_hostname_exp'] = 'Wenn ausgewählt, wird der Callback bei Änderung des '.VM_SHORT.' Hostnamen aktivert';
$l['cb_terminate'] = VM_SHORT.' Löschung';
$l['cb_terminate_exp'] = 'Wenn ausgewählt, wird der Callback bei Löschung des '.VM_SHORT.' aktiviert';
$l['cb_changeips'] = VM_SHORT.' IP Änderungen';
$l['cb_changeips_exp'] = 'Wenn ausgewählt, wird der Callback bei Aktualisierung der '.VM_SHORT.' IP-Adresse(n) aktiviert';
$l['no_use_https'] = 'Bitte wählen Sie das HTTP-Protokoll';
$l['no_cb_url'] = 'Bitte geben Sie die Callback URL';
$l['inv_cv_url'] = 'Bitte geben Sie eine gültige Callback URL ein';
$l['cb_login_whmcs_user'] = 'Aktivieren Sie die Anmeldung für WHMCS-Benutzer';
$l['cb_login_whmcs_user_exp'] = 'Wenn diese Option aktiviert ist, kann sich der WHMCS-Benutzer ohne Registrierung als Cloud-Benutzer anmelden';
$l['cb_invoice_whmcs_user'] = 'Aktivieren Sie die WHMCS Abrechnung';
$l['cb_invoice_whmcs_user_exp'] = 'Wenn dieses Kontrollkästchen aktiviert ist, wird der Saldo in der Cloud-Abrechnung von WHMCS abgerufen und die Rechnungen werden auch in WHMCS generiert';


// Proxmox Settings
$l['proxmox_settings'] = 'Proxmox-Einstellungen';
$l['proxmox_server_name'] = 'Proxmox Servername';
$l['proxmox_server_name_exp'] = 'Der Proxmox Servername kann unter /etc/hostname gefunden werden';
$l['proxmox_server_pass'] = 'Proxmox-Root-Passwort';
$l['proxmox_server_pass_exp'] = 'Proxmox-Root-Passwort, dass für den Proxmox-Panel-Login verwendet wird';

// Cloud users settings
$l['cloud_user_settings'] = 'Cloud-Benutzer Einstellung';
$l['cloud_allow_virtio'] = 'Virtio verwaltung erlauben';
$l['cloud_allow_virtio_exp'] = 'Wenn diese Option aktiviert ist, können Cloud-Benutzer virtio für ihre '.VM_SHORT.' aktivieren';

$l['logo_login_url'] = 'Logo URL (Loginseite)';
$l['logo_login_url_exp'] = 'Die empfohlene Größe beträgt 400 x 80 Pixel. Wenn das Feld leer bleibt, wird das Virtualizor-Logo angezeigt';

$l['allow_cloud_ebt_disable'] = 'Allow disable ebtables';
$l['allow_cloud_ebt_disable_exp'] = 'Allow cloud user to disable ebtables rules for their '.VM_SHORT.'. Ebtables rules prevent IP stealing (These rules prevent '.VM_SHORT.' from using IP not assigned to it)';

// Server Location
$l['server_location_set'] = 'Server-Standorteinstellungen';
$l['select_country'] = 'Select your country code';
$l['country_code'] = 'Country Code';
$l['country_code_exp'] = 'Set the country code where your server is located';
$l['city'] = 'City';
$l['city_exp'] = 'Set the city where your server is located';
$l['state'] = 'State';
$l['state_exp'] = 'Set the state where your server is located';

// Backup Settings
$l['backup_settings'] = 'Endbenutzer Backup-Einstellungen';
$l['backup_queue'] = 'Backup-Warteschlange';
$l['backup_queue_exp'] = 'Maximale Anzahl gleichzeitiger Endbenutzer-Backups die Sie erlauben möchten. Null für unbegrenzt festlegen.';
$l['restore_queue'] = 'Wiederherstellungswarteschlange';
$l['restore_queue_exp'] = 'Maximale Anzahl gleichzeitiger Endbenutzer-Wiederherstellungsvorgänge die Sie erlauben möchten. Null für unbegrenzt festlegen.';
$l['enable_enduser_backup_servers'] = 'Aktivieren Sie Backup-Server im Kundenbereich';
$l['enable_enduser_backup_servers_exp'] = 'Erlaubt Endbenutzern ihre eigenen Backup-Server für '.VM_SHORT.'-Backups hinzuzufügen.<br /> <b>HINWEIS:</b> Wenn dies aktiviert wird, überschreibt dies die Einstellungen in allen Backup-Vorlagen.';
$l['nw_settings'] = 'Netzwerkeinstellungen';
$l['backup_email'] = 'Backup / Wiederherstellen E-Mail';
$l['backup_email_exp'] = 'Die E-Mail, in der die Backup- / Wiederherstellungs-E-Mails für Erfolgs- und Fehlermeldungen gesendet werden.<br /><b>Hinweis:</b> Wenn leer, werden die E-Mails an die E-Mail-Adresse des Administrators gesendet.';
$l['backup_disable_success_mail'] = 'Deaktivieren Sie die Backup- / Wiederherstellungs-E-Mails bei Erfolg';
$l['backup_disable_success_mail_exp'] = 'Wenn diese Option aktiviert ist, werden die Backup- / Wiederherstellungs-E-Mails nicht an den Administrator gesendet.<br /><b>HINWEIS:</b> Fehler-E-Mails werden immer gesendet, unabhängig von dieser Einstellung.';

// Max IPs
$l['max_ips_setting'] = 'IP settings';
$l['max_ipv4s'] = 'Max IPv4 per '.VM_SHORT;
$l['max_ipv4s_exp'] = 'Max number of IPv4 addresses allowed per '.VM_SHORT;
$l['max_ipv6s'] = 'Max IPv6 per '.VM_SHORT;
$l['max_ipv6s_exp'] = 'Max number of IPv6 addresses allowed per '.VM_SHORT;
$l['max_ipv6_subnets'] = 'Max IPv6 Subnet per '.VM_SHORT;
$l['max_ipv6_subnets_exp'] = 'Max number of IPv6 subnet allowed per '.VM_SHORT;
$l['max_internal_ips'] = 'Max Internal IPs per '.VM_SHORT;
$l['max_internal_ips_exp'] = 'Max number of Internal IP addresses allowed per '.VM_SHORT;

$l['allow_cloud_dom_name'] = 'Allow cloud user domain name';
$l['exp_allow_cloud_dom_name'] = 'Allow cloud user domain name for login';

$l['resource_pref_load'] = 'Least System Load';
$l['resource_pref_space'] = 'Most Available Space';
$l['resource_pref_ram'] = 'Most Available Ram';
$l['resource_pref_cores'] = 'Most Available Cores';
$l['resource_pref_ips'] = 'Most Available IPv4';
$l['resource_pref_ipv6'] = 'Most Available IPv6';
$l['resource_pref_ipv6sub'] = 'Most Available IPv6 Subnets';
$l['resource_pref_numvps'] = 'Least Number of '.VM_SHORT;
$l['resource_pref_none'] = 'None';
$l['resource_sg_pref'] = 'Sever Group Preferences';
$l['resource_sg_sel'] = 'Server Selection';

$l['disable_recipe_reinstall'] = 'Disable recipe execution on rebuild';
$l['disable_recipe_reinstall_exp'] = 'If enabled, then recipe set in '.VM_SHORT.' Plan will not get executed';
$l['use_win_script'] = 'Use Windows Configuration script';
$l['use_win_script_exp'] = 'If enabled Static ips, Location and other operations will be performed';

$l['disable_notifications'] = 'Disable Notifications';

$l['hide_acc_password'] = 'Hide Account Password';
$l['hide_acc_password_exp'] = 'If enabled, then user will not be able to change the account password from the enduser panel';
$l['hide_forgot_password'] = 'Hide Forgot Password link';
$l['hide_forgot_password_exp'] = 'If enabled, then user will not be able to reset the password on login page';

$l['allow_cloud_url_reg'] = 'Allow cloud user URL';
$l['exp_allow_cloud_url_reg'] = 'Allow cloud user URL for login';
$l['server_ram_threshold'] = 'Set RAM threshold to lock server (%)';
$l['server_ram_threshold_exp'] = 'If provided then server will be locked after exceeding threshold value of RAM';
$l['server_disk_threshold'] = 'Set Primary storage threshold to lock server (%)';
$l['server_disk_threshold_exp'] = 'If provided then server will be locked after exceeding threshold value of primary storage';


$l['disable_enduser_panel'] = 'Disable Enduser Panel';
$l['disable_enduser_panel_exp'] = 'If enabled, Enduser panel access will be disabled';


$l['error_state_city'] = 'You cannot set city / state without country. Please select the country first';
$l['default_enduser_timezone'] = 'Default Enduser timezone';
$l['default_enduser_timezone_exp'] = 'If set then '.VM_SHORT.' will get the default timezone as selected. Enduser can set different timezone as per their choice from enduser panel';
$l['no_timezone'] = 'None';
$l['show_server_selection_logs'] = 'Show Server Selection logs';
$l['show_server_selection_logs_exp'] = 'Display server selection logs on task page inside create '.VM_SHORT.' task';
$l['compression_algo'] = 'Compression algorithm';
$l['compression_algo_exp'] = 'Choose the compression algorithm, for proxmox (zstd, lzop is only supported) (on ubuntu zstd is experimental)';
$l['no_compression_algo'] = 'None';
$l['disable_volumes'] = 'Disable Volume';
$l['disable_volumes_exp'] = 'If enabled, volume management will be disabled from cloud panel';
$l['disable_lb_enduser'] = 'Disable Load Balancer';
$l['disable_lb_enduser_exp'] = 'If enabled, load balancer management will be disabled from cloud panel';
$l['disable_virtvps'] = 'Do not show virtualization type';
$l['disable_virtvps_exp'] = 'If enabled, virtualization type column will not be shown on listvs page in enduser panel';

//Vertical scaling 
$l['enable_ver_scaling'] = 'Enable vertical scaling';
$l['default'] = 'Default';
$l['ver_scale_settings'] = 'Vertical Scaling Settings';
$l['ver_ram_settings'] = 'RAM Settings';
$l['ver_max_ram'] = 'Max RAM (in MB)';
$l['ver_max_ram_exp'] = 'Provide the maximum amount of RAM that will be allocated to '.VM_SHORT.' ';
$l['ver_max_ram_err'] = 'Please specify Max RAM';
$l['ver_ram_threshold'] = 'RAM Threshold (in %)';
$l['ver_ram_threshold_exp'] = 'If the '.VM_SHORT.' RAM usage is greater/less than threshold provided scaling will be performed accordingly';
$l['ver_ram_threshold_err'] = 'Please specify RAM Threshold';
$l['ver_ram_inc_by'] = 'Increase/Decrease RAM By (in GB)';
$l['ver_ram_inc_by_exp'] = 'If the threshold exceeds/subceeds, the provided RAM (in GB) will be increased or decreased accordingly';
$l['ver_ram_inc_by_err'] = 'Please specify Increase/Decrease RAM';

$l['ver_cpu_settings'] = 'CPU Settings';
$l['ver_max_cpu'] = 'Max CPU Cores';
$l['ver_max_cpu_exp'] = 'Provide the maximum amount of cpu cores that will be allocated to '.VM_SHORT.' ';
$l['ver_max_cpu_err'] = 'Please specify Max CPU';
$l['ver_cpu_threshold'] = 'CPU Threshold (in %)';
$l['ver_cpu_threshold_exp'] = 'If the VPS cpu usage is greater/less than threshold provided scaling will be performed accordingly';
$l['ver_cpu_threshold_err'] = 'Please specify CPU Threshold';
$l['ver_cpu_inc_by'] = 'Increase/Decrease CPU Cores By';
$l['ver_cpu_inc_by_exp'] = 'If the threshold exceeds/subceeds, the provided cores will be increased or decreased accordingly';
$l['ver_cpu_inc_by_err'] = 'Please specify Increase/Decrease CPU Cores';
$l['ver_scaling_note'] = '<ol class="pl-2 mb-1">
<li>Vertical scaling is supported on KVM based virtualization only.</li>
<li>QEMU version should be greater than or equal to 1.5, To check QEMU Version run "/usr/bin/virsh version"</li>
<li>Vertical scaling is currently not supported on Windows '.VM_SHORT.'</li>
</ol>';
$l['hide_eu_tasks'] = 'Hide Tasks Log';
$l['hide_eu_tasks_exp'] = 'If enabled, then enduser will not be able to see task logs';
$l['save_vm_pass'] = 'Save Password of '.VM_SHORT;
$l['save_vm_pass_exp'] = 'If enabled, then '.VM_SHORT.' password will be stored and will be visible to Endusers only. Admin will not be able to see the password.';
$l['memory_limit'] = 'Memory Limit (in MBs)';
$l['memory_limit_exp'] = 'You can increase memory limit if you are facing syncing issues, by default it will be 128M';
$l['slave_low_space'] = 'You do not have enough disk space on slave server';
$l['proxmox_tfa_secret'] = 'Proxmox 2FA secret';
$l['proxmox_tfa_secret_exp'] = 'Enter the secret obtained from Proxmox 2FA';
$l['dont_delete_bw_from_db'] = 'Do not delete Bandwidth data';
$l['dont_delete_bw_from_db_exp'] = 'If checked, then bandiwdth data for each 5 minute will not be deleted';
$l['temporary_st_directory'] = 'Temporary Backup Directory';
$l['temporary_st_directory_exp'] = 'During Remote Backup Temporary data will be stored in this directory';
$l['no_temp_dir_exists'] = 'Temporary Directory does not exist';
$l['add_ptr_record'] = 'Add PTR records';
$l['add_ptr_record_exp'] = 'PTR records for the VPS\'s will be added after VM creation, VM\'s hostname will be used for adding the records.';
$l['no_pdns_servers'] = 'There are no PDNS Server, to add PTR records.<br/><a href="'.$globals['index'].'act=addpdns">Add a PDNS Server now</a>';

// LDAP
$l['enable_ldap_auth'] = 'Enable LDAP Authentication';
$l['enable_ldap_auth_exp'] = 'Admin login Authentication will be done with LDAP server ';
$l['ldap_server'] = 'LDAP Server';
$l['ldap_server_exp'] = 'Enter the LDAP server Hostname or IP address';
$l['ldap_port'] = 'LDAP Port';
$l['ldap_port_exp'] = 'Enter the LDAP server Port ( Default is 389 )';
$l['ldap_admin_username'] = 'LDAP Admin';
$l['ldap_admin_username_exp'] = 'Enter the dn (distinguished name) of LDAP admin user <br /> eg :- cn=admin,dc=ldapserver,dc=local';
$l['ldap_admin_password'] = 'LDAP Password';
$l['ldap_search_base'] = 'LDAP user\'s dn (distinguished name)';
$l['ldap_search_base_exp'] = 'Enter the search base from which users will be authenticated. <br /> eg :- ou=users,dc=ldapserver,dc=local <br />Please Note:<br /><ul><li>Entry of the user must be present on LDAP Server, and Mail attribute of the user must be set, or else users will not be able to login</li></ul>';
$l['no_ldap_server'] = 'Please enter the LDAP Server';
$l['no_ldap_admin_username'] = 'Please enter the LDAP Admin username';
$l['no_ldap_admin_password'] = 'Please enter the LDAP Admin password';
$l['no_ldap_search_base'] = 'Please enter the LDAP user\'s search base';
$l['inv_ldap_search_base'] = 'Please enter the valid LDAP Search Base';

$l['disable_guest_agent'] = 'Disable Guest Agent';
$l['disable_guest_agent_exp'] = 'If enabled, then few operations like password change, fetch ram and disk actual usage will not be possible on live machine';
$l['enable_vm_setup_wizard'] = 'Enable '.VM_SHORT.' Setup for enduser';
$l['enable_vm_setup_wizard_exp'] = 'If enabled, '.VM_SHORT.' will not be created from admin panel. User will be able to choose OS and password';

$l['disable_enduser_vps_poweroff'] = 'Disable '.VM_SHORT.' Power Off';
$l['disable_enduser_vps_poweroff_exp'] = 'If enabled, '.VM_SHORT.' Power Off will be disabled for the enduser.';
$l['disable_enduser_firewall'] = 'Disable Firewall';
$l['disable_enduser_firewall_exp'] = 'If enabled, '.VM_SHORT.' Firewall will be disabled for the enduser.';
